#include-once
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include <DateTimeConstants.au3>
#include <GUIListview.au3>
; ------------------------------------------------------------------------------
;
; AutoIt Version:     3.0
; Language:         English
; Description: Multi-column editable Listview  (EditInPlace)
;                    Stephen Podhajecki <gehossafats at netmdc.com/> Gary Frost <gafrost at charter dot net/>
;                    pdm for control array concept
;                    see http://www.autoitscript.com/forum/index.ph...mp;#entry322551
;==============================================================================
;    ######>>> set the type of control for each column <<<######
;    0 = Input/edit  1 = combobox 2 = date control
;    Global $LVcolControl[4]=[0,0,1,2]
;    _InitEditLib();######>>>  add this before your ListView <<<######
;    _MonitorEditState($Gui, $editCtrl, $editFlag, $LISTVIEWCTRL, $LVINFO, $LVcolControl);######>>>  add this in your message loop<<<######
;    _TermEditLib();######>>>  add this after your message loop<<<######
; $LISTVIEWCTRL = $ListView1 ######>>> Set this to your ListView control <<<######
;==============================================================================


Global Const $DebugIt = 1
;Global Const $WM_NOTIFY = 0x004E
;Global Const $WM_KEYDOWN = 0x0100
;Global Const $NM_FIRST = 0
;Global Const $NM_CLICK = ($NM_FIRST - 2)
;Global Const $NM_DBLCLK = ($NM_FIRST - 3)
;Global Const $LVN_ENDLABELEDITA = (-106)
Global $old_col
Global $LISTVIEWCTRL = -999
Global $Gui, $editFlag
Global $editCtrl ;= the CtrlId of the editing control.
;;array dim to number of cols, value of each element determines control.
Global $LVcolControl[1] = [0] ;0= edit, 1= combo, 2= calendar
Global $lvEdit, $lvCombo, $lvDate
Global $LVINFO[8]

Opt("GUICloseOnESC", 0);turn off exit on esc.

Func __IsPressedMod($dll = "user32.dll")
	Local $aR, $bRv, $hexKey, $i
	For $i = 8 To 128
		$hexKey = '0x' & Hex($i, 2)
		$aR = DllCall($dll, "int", "GetAsyncKeyState", "int", $hexKey)
		If $aR[0] <> 0 Then Return $i
		If Mod($i, 10) = 0 Then Sleep(5)
	Next
	Return 0
EndFunc   ;==>__IsPressedMod

;===============================================================================
; Function Name:    _CancelEdit
; Description:        Cancels the editing process, and kills the hot keys.
; Parameter(s):
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func _CancelEdit()
	HotKeySet("{Enter}")
	HotKeySet("{Esc}")
	Send("{Enter}");quit edit mode
	$editFlag = 0
	$update = 0
	GUICtrlSetState($editCtrl, $GUI_HIDE)
	GUICtrlSetPos($editCtrl, 0, 0, 1, 1)
EndFunc   ;==>_CancelEdit

;===============================================================================
; Function Name:    _DebugHeader
; Description:        Gary's console debug header.
; Parameter(s):            $s_text         - IN -
;
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func _DebugHeader($s_text)
	Return _
			"!===========================================================" & @LF & _
			"+===========================================================" & @LF & _
			"-->" & $s_text & @LF & _
			"+===========================================================" & @LF
EndFunc   ;==>_DebugHeader

;===============================================================================
; Function Name:    _FillLV_Info
; Description:        This fills the passed in array with row col and rect info for
;                        used by the editing controls
; Parameter(s):            $LISTVIEWCTRL         - IN/OUT -
;                    $iRow         - IN -
;                    $iCol         - IN -
;                    $aLVI         - IN/OUT -
;
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func _FillLV_Info(ByRef $LISTVIEWCTRL, $iRow, $iCol, ByRef $aLVI)
	If $iRow < 0 Or $iCol < 0 Then Return 0
	Local $lvi_rect[4], $ret, $pos = ControlGetPos("", "", $LISTVIEWCTRL)
	$ret = _GUICtrlListViewGetSubItemRect($LISTVIEWCTRL, $iRow, $iCol, $lvi_rect)
	$aLVI[6] = $aLVI[0]
	$aLVI[7] = $aLVI[1]
	$aLVI[0] = $iRow
	$aLVI[1] = $iCol
	$aLVI[2] = $pos[0] + $lvi_rect[0] + 5
	$aLVI[3] = $pos[1] + $lvi_rect[1]
	$aLVI[4] = _GUICtrlListView_GetColumnWidth($LISTVIEWCTRL, $iCol) - 4
	$aLVI[5] = $lvi_rect[3] + 5
	Return 1
EndFunc   ;==>_FillLV_Info


;===============================================================================
; Function Name:    _GUICtrlListViewGetSubItemRect
; Description:     Get the bounding rect of a listview item
; Parameter(s):    $h_listview         - IN -
;                        $row         - IN -
;                        $col         - IN -
;                        $aRect         - IN/OUT -
;
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func _GUICtrlListViewGetSubItemRect($h_listview, $row, $col, ByRef $aRect)
	Local $rectangle, $rv
	$rectangle = DllStructCreate("int;int;int;int") ;left, top, right, bottom
	DllStructSetData($rectangle, 1, $LVIR_BOUNDS)
	DllStructSetData($rectangle, 2, $col)
	If IsHWnd($h_listview) Then
		Local $a_ret = DllCall("user32.dll", "int", "SendMessage", "hwnd", $h_listview, "int", $LVM_GETSUBITEMRECT, "int", $row, "ptr", DllStructGetPtr($rectangle))
		$rv = $a_ret[0]
	Else
		$rv = GUICtrlSendMsg($h_listview, $LVM_GETSUBITEMRECT, $row, DllStructGetPtr($rectangle))
	EndIf
	ReDim $aRect[4]
	$aRect[0] = DllStructGetData($rectangle, 1)
	$aRect[1] = DllStructGetData($rectangle, 2)
	$aRect[2] = DllStructGetData($rectangle, 3)
	$aRect[3] = DllStructGetData($rectangle, 4) - $aRect[1]
	$rectangle = 0
	Return $rv
EndFunc   ;==>_GUICtrlListViewGetSubItemRect

;===============================================================================
; Function Name:    _InitEdit
; Description:        Bring forth the editing control and set focus on it.
; Parameter(s):    $LVINFO         - IN -
;                        $LVcolControl         - IN -
;
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func _InitEdit($LVINFO, $LVcolControl)
	Local $CtrlType
	If $LVINFO[0] < 0 Or $LVINFO[1] < 0 Then Return 0
	If UBound($LVcolControl) - 1 < $LVINFO[1] Then
		$CtrlType = 0
	Else
		$CtrlType = $LVcolControl[$LVINFO[1]]
	EndIf
	;----------------------------------------------------------------------------------------------
	If $DebugIt Then ConsoleWrite(_DebugHeader("$CtrlType:" & $CtrlType))
	;----------------------------------------------------------------------------------------------

	Switch $CtrlType
		Case 1
			$editCtrl = $lvCombo
		Case 2
			$editCtrl = $lvDate
		Case Else
			GUICtrlSetData($lvEdit, "")
			$editCtrl = $lvEdit
	EndSwitch
	GUICtrlSetPos($editCtrl, $LVINFO[2], $LVINFO[3], $LVINFO[4], $LVINFO[5])
	Local $oldText = _GUICtrlListView_GetItemText($LISTVIEWCTRL, $LVINFO[0], $LVINFO[1])
;~         $LVINFO[6]=$LVINFO[0];save edit row and col
;~         $LVINFO[7]=$LVINFO[1];save edit row and col
	GUICtrlSetData($editCtrl, $oldText)
	GUICtrlSetState($editCtrl, $GUI_SHOW)
	GUICtrlSetState($editCtrl, $GUI_FOCUS)
	$editFlag = 1
EndFunc   ;==>_InitEdit

;===============================================================================
; Function Name:    _InitEditLib
; Description:        Create the editing controls and registers WM_NOTIFY handler.
; Parameter(s):
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):        Call this BEFORE you create your listview.
;===============================================================================
Func _InitEditLib()
	$lvEdit = GUICtrlCreateInput("", 0, 0, 1, 1, BitOR($ES_AUTOHSCROLL, $ES_NOHIDESEL, $WS_BORDER), 0)
	GUICtrlSetState($lvEdit, $GUI_HIDE)
	$lvCombo = GUICtrlCreateCombo("", 0, 0, 1, 1)
	GUICtrlSetState($lvCombo, $GUI_HIDE)
	$lvDate = GUICtrlCreateDate("", 0, 0, 1, 1, $DTS_SHORTDATEFORMAT)
	GUICtrlSetState($lvDate, $GUI_HIDE)
	GUIRegisterMsg($WM_NOTIFY, "WM_Notify_Events")
EndFunc   ;==>_InitEditLib
; WM_NOTIFY event handler

;===============================================================================
; Function Name:    _MonitorEditState
; Description:        Handles {enter} {esc} and {f2}
; Parameter(s):    $h_gui     - IN/OUT -
;                        $editCtrl     - IN/OUT -
;                        $editFlag     - IN/OUT -
;                        $LISTVIEWCTRL     - IN/OUT -
;                        $LVINFO     - IN/OUT -
;                        $LVcolControl         - IN -
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func _MonitorEditState(ByRef $h_gui, ByRef $editCtrl, ByRef $editFlag, ByRef $LISTVIEWCTRL, ByRef $LVINFO, $LVcolControl)
	Local $pressed = __IsPressedMod()
	If $editFlag And $pressed = 13 Then; pressed enter
		Update($editCtrl, $LISTVIEWCTRL, $LVINFO[0], $LVINFO[1])
	ElseIf $editFlag And $pressed = 27 Then; pressed esc
		_CancelEdit()
		$editFlag = 0
	ElseIf Not $editFlag And $pressed = 113 Then; pressed f2
		;_InitEdit($LVINFO, $LVcolControl); hmmm, the control doesn't always focus correctly
		MouseClick("primary") ;workaround work all the time (if mouse is over the control)
		MouseClick("primary")
	EndIf
	Sleep(50)
EndFunc   ;==>_MonitorEditState
;===============================================================================
; Function Name:    _TermEditLib
; Description:        Deletes the editing controls and un-registers WM_NOTIFY handler.
; Parameter(s):
;Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):        Call this when close your gui if switching to another gui.
;===============================================================================
Func _TermEditLib()
	GUICtrlDelete($lvEdit)
	GUICtrlDelete($lvCombo)
	GUICtrlDelete($lvDate)
	GUIRegisterMsg($WM_NOTIFY, "")
EndFunc   ;==>_TermEditLib

Func Enter()
	; just a dummy function
EndFunc   ;==>Enter

;===============================================================================
; Function Name:    ListView_Click
; Description:    Called from WN_NOTIFY event handler.
; Parameter(s):
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func ListView_Click()
	;----------------------------------------------------------------------------------------------
	If $DebugIt Then ConsoleWrite(_DebugHeader("$NM_CLICK"))
	;----------------------------------------------------------------------------------------------
	Sleep(50)
	If $editFlag = 1 Then
		If UBound($LVcolControl) - 1 < $LVINFO[1] Then
			_CancelEdit()
		Else
			Update($editCtrl, $LISTVIEWCTRL, $LVINFO[6], $LVINFO[7])
		EndIf
	EndIf
EndFunc   ;==>ListView_Click

;===============================================================================
; Function Name:    ListView_DoubleClick
; Description:    Called from WN_NOTIFY event handler.
; Parameter(s):
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):            Initiates the edit process on a DblClick
;===============================================================================
Func ListView_DoubleClick()
	;----------------------------------------------------------------------------------------------
	If $DebugIt Then ConsoleWrite(_DebugHeader("$NM_DBLCLICK"))
	;----------------------------------------------------------------------------------------------
	If $editFlag = 0 Then
		_InitEdit($LVINFO, $LVcolControl)
	Else
		_CancelEdit()
	EndIf
EndFunc   ;==>ListView_DoubleClick

;===============================================================================
; Function Name:    Update
; Description:        Put the new data in the Listview
; Parameter(s):    $editCtrl         - IN/OUT -
;                        $LISTVIEWCTRL         - IN/OUT -
;                        $iRow         - IN -
;                        $iCol         - IN -
;
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func Update(ByRef $editCtrl, ByRef $LISTVIEWCTRL, $iRow, $iCol)
	Local $newText = GUICtrlRead($editCtrl)
	Local $item = GUICtrlRead($LISTVIEWCTRL)
	_GUICtrlListView_SetItemText($LISTVIEWCTRL, $iRow, $newText, $iCol)
	_CancelEdit()
EndFunc   ;==>Update

;===============================================================================
; Function Name:    WM_Notify_Events
; Description:        Event handler for windows WN_NOTIFY messages
; Parameter(s):    $hWndGUI         - IN -
;                        $MsgID         - IN -
;                        $wParam         - IN -
;                        $lParam         - IN -
;
; Requirement(s):
; Return Value(s):
; User CallTip:
; Author(s):
; Note(s):
;===============================================================================
Func WM_Notify_Events($hWndGUI, $MsgID, $wParam, $lParam)
	#forceref $hWndGUI, $MsgID, $wParam
	Local $tagNMHDR, $event, $from
	$tagNMHDR = DllStructCreate("int;int;int", $lParam);NMHDR (hwndFrom, idFrom, code)
	If @error Then Return
	$from = DllStructGetData($tagNMHDR, 1)
	$event = DllStructGetData($tagNMHDR, 3)
	Select
		Case $wParam = $LISTVIEWCTRL
			Select
				Case $event = $NM_CLICK
					$tNMITEMACTIVATE = DllStructCreate("int;int;int;int;int;int;int;int;int", $lParam)
					$clicked_row = DllStructGetData($tNMITEMACTIVATE, 4)
					$clicked_col = DllStructGetData($tNMITEMACTIVATE, 5)
					$tNMITEMACTIVATE = 0
					_FillLV_Info($LISTVIEWCTRL, $clicked_row, $clicked_col, $LVINFO)
					ConsoleWrite("Column:" & $clicked_col & @LF)
					ConsoleWrite("Row:" & $clicked_row & @LF)
					$old_col = $clicked_col
					ListView_Click()
				Case $event = $NM_DBLCLK
					ListView_DoubleClick()
			EndSelect
		Case $MsgID = $WM_KEYDOWN
			ConsoleWrite("Keydown" & @LF)

	EndSelect
	$tagNMHDR = 0
	$event = 0
	$lParam = 0
EndFunc   ;==>WM_Notify_Events
