#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include <GUIListview.au3>

Opt("MustDeclareVars", 1)
Opt("GUICloseOnESC", 0)

Global $a_data[20][3] = [["Me", 10, 13.5], ["You", 12, 27.8], ["her", 17, 17.17], ["him", 9, 9.9], ["she", 8, 8.8], ["it", 7, 7.7], ["dau", 6, 6.6], ["dummy", 5, 5.5]]
Global $current_col = -1, $clicked_col = 0
Global $current_row = -1

#include <GUIConstants.au3>

Global $Form1 = GUICreate("AForm1", 393, 212, 303, 219, BitOR($WS_MAXIMIZEBOX, $WS_MINIMIZEBOX, $WS_SIZEBOX, $WS_THICKFRAME, $WS_SYSMENU, $WS_CAPTION, $WS_OVERLAPPEDWINDOW, $WS_TILEDWINDOW, $WS_POPUPWINDOW, $WS_GROUP, $WS_TABSTOP, $WS_BORDER, $WS_CLIPSIBLINGS))
Global $ListView = GUICtrlCreateListView("Name|Rounds|Total", 24, 24, 350, 150, -1, BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
Global $inb_edit = GUICtrlCreateInput("inb_edit", 24, 120, 89, 21, BitOR($ES_AUTOHSCROLL, $ES_NOHIDESEL, $WS_BORDER), 0)
GUICtrlSetBkColor(-1, 0xC0DCC0)
GUISetState(@SW_SHOW)

Local $open = 0, $mouse_click = False
Local $editfield_on
Local $last_row, $last_col

For $l = 0 To 9
    GUICtrlCreateListViewItem($a_data[$l][0] & "|" & $a_data[$l][1] & "|" & $a_data[$l][2], $ListView)
    $last_row = $l
Next

$last_col = UBound($a_data, 2) - 1

main()

Func main()
    Local $msg
    
    GUIRegisterMsg($WM_NOTIFY, "WM_Notify_Events")
    
    $editfield_on = GUICtrlCreateDummy()     ;generate unique code for the message handling

    l_edit_quit()
    While 1
        $msg = GUIGetMsg()
        Switch $msg
            Case $GUI_EVENT_CLOSE
                ExitLoop
            Case $ListView
                ;_con ("lv-msg")
            Case $inb_edit
                ;_con ("edit-msg")
                l_edit_save()
            Case $editfield_on
                l_edit_on()
            Case 0, -7, -8, -11, -12
            Case Else
                _con("msg=" & $msg);
        EndSwitch
    WEnd
EndFunc   ;==>main

Func l_edit_save()
    If $open = 2 Then
        ;_con ("save open="& $open)
        $a_data[$current_row][$current_col] = GUICtrlRead($inb_edit)
        _GUICtrlListView_SetItemText($ListView, $current_row, $a_data[$current_row][$current_col], $current_col)
        $open = 1
    EndIf
    l_edit_quit()
EndFunc   ;==>l_edit_save

Func l_edit_quit()
    If $open <> 0 Then
        ;_con ("quit open="& $open)
        GUICtrlSetState($inb_edit, $GUI_HIDE)
        GUICtrlSetState($ListView, $GUI_ONTOP + $GUI_FOCUS)
        $open = 0
        HotKeySet("{Enter}")
        HotKeySet("{TAB}")
        HotKeySet("+{TAB}")
        HotKeySet("{DOWN}")
        HotKeySet("{UP}")
        HotKeySet("{ESC}")
    EndIf
    If $mouse_click Then
        $mouse_click = False
        MouseClick("left")
    EndIf
EndFunc   ;==>l_edit_quit

Func ListView_Click($lv)
    ;_con ("lv click open="& $open &" clicked col="& $clicked_col)
    If $clicked_col < 0 Then
        _con("off mcl=" & $mouse_click)
        l_edit_save()
        Return
    EndIf
    If $open = 2 Then
        l_edit_save()
    ElseIf $open = 1 Then
        Return
    EndIf

    $open = 1
    $mouse_click = True
    l_prepare_edit(_GUICtrlListView_GetNextItem($ListView), $clicked_col)
EndFunc   ;==>ListView_Click

Func l_prepare_edit($row, $col)
    Local $left, $top, $height, $width, $lvw, $a_coord[4], $str, $shift, $colw, $rowh, $vs, $hs, $hh, $sw, $sh

    ;_con ("prepare open="& $open)
    $current_row = $row
    If $current_row < 0 Then
        ;$current_row = 0
        Return
    EndIf
    $current_col = $col
    If $current_col < 0 Then $current_col = 0
    _GUICtrlListView_EnsureVisible($ListView, $current_row, 0)

    $width = _GUICtrlListView_GetColumnWidth($ListView, $current_col)
    _GUICtrlListViewGetSubItemRect($ListView, $current_row, $current_col, $left, $top, $height)
    $colw = $width + 2
    If $current_col = $last_col Then
        For $c = 0 To $current_col - 1
            $colw += _GUICtrlListView_GetColumnWidth($ListView, $c) + 1 ;+1 for the gridline
        Next
    EndIf
    $a_coord = ControlGetPos("", "", $ListView) ;get coordinates of ListView (x, y, w, h)
    If Not IsArray($a_coord) Then
        Return
    EndIf
    $str = _ArrayToString($a_coord, "/")
    $lvw = $a_coord[2] ;w
    ;_con ("lv x/y/w/h="& $str &"   left="& $left &" top="& $top &" wid="& $width &" hei="& $height &" lvw="& $lvw &" colw="& $colw)

    $hh = 20
    $sw = 24
    $sh = 20
    ;Under certain conditions, vertical and/or horizontal scrollbars will be displayed.
    ;The vertical bar reduces the usable width, which can force the horizontal bar to appear.
    ;The horizontal scrollbar reduces the number of displayed lines and can force a vertical bar to be shown.
    ;These conditions will affect the editfield in the last column.
    $rowh = $last_row * ($height + 1) + ($height - 5) ;+1 for the gridline +extra for partial height of last line
    If $rowh > ($a_coord[3] - $hh) Then
        $vs = $sw ;vertical slider exists
    Else
        $vs = 0
    EndIf
    If $colw > ($a_coord[2] - $vs) Then
        $hs = $sh ;horizontal slider exists
    Else
        $hs = 0
    EndIf
    If $rowh > ($a_coord[3] - $hh - $hs + 4) Then ;+extra due to hysteresis when horizontal bar exists and vertical one still not
        $vs = $sw ;vertical slider exists
    EndIf
    ;_con ($last_row &" rows height "& $height+1 &" *="& $rowh &" hi="& $a_coord[3] &" vs="& $vs &" hs="& $hs)
    $lvw -= $vs ;w - sliderwidth

    $shift = 0
    If $left > $lvw Then
        If $width > $lvw Then
            $width = $lvw
            $shift = 0 - $left
            $left = 0
        Else
            $shift = $left - $lvw + $width
            $left -= $shift
        EndIf
    ElseIf $left < 0 Then
        If $width > $lvw Then
            $width = $lvw
            $shift = $left
            $left = 0
        Else
            $shift = $left
            $left = 0
        EndIf
    ElseIf $left + $width > $lvw Then
        If $width > $lvw Then
            $width = $lvw
            $shift = 0 - $left
            $left = 0
        Else
            $shift = $left - $lvw + $width
            $left -= $shift
        EndIf
    EndIf
    If $shift <> 0 Then
        _GUICtrlListView_Scroll($ListView, $shift, 0)
    EndIf

    ;_con ("lv x/y/w/h="& $str &"   left="& $left &" top="& $top &" wid="& $width &" hei="& $height &" shift="& $shift &" lvw="& $lvw)

    _GUICtrlListView_SetItemSelected($ListView, $current_row, 1, 0)
    GUICtrlSetPos($inb_edit, $left + $a_coord[0] + 4, $top + $a_coord[1] + 5, $width, $height + 0)
    $open = 1
    GUICtrlSendToDummy($editfield_on) ;start edit-field
EndFunc   ;==>l_prepare_edit

Func l_edit_on()
    ;_con ("on open="& $open)
    GUICtrlSetState($inb_edit, $GUI_SHOW + $GUI_ONTOP + $GUI_FOCUS)
    GUICtrlSetData($inb_edit, $a_data[$current_row][$current_col])

    HotKeySet("{Enter}", "l_edit_right")
    HotKeySet("{TAB}", "l_edit_right")
    HotKeySet("+{TAB}", "l_edit_left")
    HotKeySet("{DOWN}", "l_edit_down")
    HotKeySet("{UP}", "l_edit_up")
    HotKeySet("{ESC}", "l_edit_quit")

    $open = 2
EndFunc   ;==>l_edit_on

Func l_edit_right()
    Local $col, $row
    
    $row = $current_row
    $col = $current_col
    If $col < $last_col Then
        $col += 1
    Else
        $col = 0
        $row += 1
    EndIf
    If $row <= $last_row Then
        l_edit_save()
        l_prepare_edit($row, $col)
    EndIf
EndFunc   ;==>l_edit_right

Func l_edit_left()
    Local $col, $row
    
    $row = $current_row
    $col = $current_col
    If $col > 0 Then
        $col -= 1
    Else
        $row -= 1
        $col = $last_col
    EndIf
    If $row >= 0 Then
        l_edit_save()
        l_prepare_edit($row, $col)
    EndIf
EndFunc   ;==>l_edit_left

Func l_edit_down()
    If $current_row < $last_row Then
        l_edit_save()
        l_prepare_edit($current_row + 1, $current_col)
    EndIf
EndFunc   ;==>l_edit_down

Func l_edit_up()
    If $current_row > 0 Then
        l_edit_save()
        l_prepare_edit($current_row - 1, $current_col)
    EndIf
EndFunc   ;==>l_edit_up

Func ListView_DoubleClick($lv)
EndFunc   ;==>ListView_DoubleClick

Func _GUICtrlListViewGetSubItemRect($h_listview, $row, $col, ByRef $left, ByRef $top, ByRef $height)
    Local $rectangle, $rv
    
    $rectangle = DllStructCreate("int;int;int;int") ;left, top, right, bottom
    DllStructSetData($rectangle, 1, $LVIR_BOUNDS)
    DllStructSetData($rectangle, 2, $col)
    If IsHWnd($h_listview) Then
        Local $a_ret = DllCall("user32.dll", "int", "SendMessage", "hwnd", $h_listview, "int", $LVM_GETSUBITEMRECT, "int", $row, "ptr", DllStructGetPtr($rectangle))
        $rv = $a_ret[0]
    Else
        $rv = GUICtrlSendMsg($h_listview, $LVM_GETSUBITEMRECT, $row, DllStructGetPtr($rectangle))
    EndIf
    $left = DllStructGetData($rectangle, 1)
    $top = DllStructGetData($rectangle, 2)
    $height = DllStructGetData($rectangle, 4) - $top
    $rectangle = 0
    Return $rv
EndFunc   ;==>_GUICtrlListViewGetSubItemRect

; WM_NOTIFY event handler
Func WM_Notify_Events($hWndGUI, $MsgID, $wParam, $lParam)
    #forceref $hWndGUI, $MsgID, $wParam
    Local $tagNMHDR, $event, $tagNMITEMACTIVATE, $rv
	
    $rv = $GUI_RUNDEFMSG
    $tagNMHDR = DllStructCreate("int;int;int", $lParam);NMHDR (hwndFrom, idFrom, code)
    If @error Then Return
    $event = DllStructGetData($tagNMHDR, 3)
    $rv = 0
    Switch $wParam
        Case $ListView
            Switch $event
                Case $NM_CLICK
                    ListView_Click($ListView)
                Case $NM_DBLCLK
                    ListView_DoubleClick($ListView)
                Case - 121 ;click inside the listview data area
                    $tagNMITEMACTIVATE = DllStructCreate("int;int;int;int;int;int;int;int;int", $lParam)
                    $clicked_col = DllStructGetData($tagNMITEMACTIVATE, 5)
                    $tagNMITEMACTIVATE = 0
                Case - 108, -177, -180, -181 ;header-click, horizontal scroll, vertical scroll up and down
                    l_edit_save()
                Case Else
                    ;_con ("lvw evnt="& $event)
            EndSwitch
        Case $inb_edit
            Switch $event
                Case 0
                Case Else
                    ;_con ("inb evnt="& $event)
            EndSwitch
        Case Else
            Switch $event
                Case - 322, -328 ;changes in column width
                    l_edit_save()
                Case Else
                    ;_con ("ctrl "& $hWndGUI &" evnt="& $event)
            EndSwitch
    EndSwitch
    $tagNMHDR = 0
    $event = 0
    $lParam = 0
    Return $rv
EndFunc   ;==>WM_Notify_Events

Func _con($msg, $eol = @CRLF)
    ConsoleWrite($msg & $eol)
EndFunc   ;==>_con

Func _msg($msg, $time = 0)
    MsgBox(0, "title", $msg, $time)
EndFunc   ;==>_msg
